import Stomp from 'stompjs';
export declare enum CONNECT_STATE {
    DISCONNECTED = 0,
    CONNECTING = 1,
    CONNECTED = 2
}
export declare enum BREAK_REASON {
    INVALID_TOKEN = 0,
    MANUAL_DISCONNECT = 1
}
interface RetryOpts {
    /**
     * milliseconds for next re-connect
     */
    timeout?: number;
}
export interface SocketOpts {
    base: string;
    projectId: string;
    token: string;
    reconnect?: RetryOpts | false;
}
export interface StateChangeCallback {
    (state: CONNECT_STATE): void;
}
interface SockMessage extends Stomp.Message {
    body: string;
    command: string;
}
export interface BroadcastCallback {
    (message: SockMessage): void;
}
export interface BroadcastCallbacks {
    [topic: string]: Array<BroadcastCallback>;
}
export interface SingleSubscribeCallback {
    (message: SockMessage): void;
}
export {};
